<?php
 
/*
 * stopwords management
 */
if (!defined('DOKU_INC'))
	define('DOKU_INC', realpath(dirname(__FILE__) . '/../../') . '/');
if (!defined('DOKU_PLUGIN'))
	define('DOKU_PLUGIN', DOKU_INC . 'lib/plugins/');
require_once (DOKU_PLUGIN . 'admin.php');
 
class admin_plugin_cloud extends DokuWiki_Admin_Plugin {
 
	/**
	 * function constructor
	 */
	function admin_plugin_cloud() {
		// enable direct access to language strings
		$this->setupLocale();
	}
 
	/**
	 * return some info
	 */
	function getInfo() {
		return array (
			'author' => 'Kite',
			'email' => 'kite@puzzlers.org',
			'date' => '2008-07-11',
			'name' => 'Stopwords management',
			'desc' => 'Manage stopwords for the cloud plugin',
			'url' => 'http://www.dokuwiki.org/plugin:cloud',	
		);
	}
 
	function handle() {
	}
 
    function getMenuText($language) {
        return $this->getLang('Admin_MenuText');  //'Stopwords management';
    }
 
	function stopwords_fn() {
		return DOKU_CONF . 'stopwords.txt';
	}
 
	function save_stopwords() {
		//ptln('<!-- $_REQUEST = ' . print_r($_REQUEST, true) . ' -->');
		//ptln('<!-- $_POST = ' . print_r($_POST, true) . ' -->');
		if($_REQUEST['stopwords']) {
			$sw = $_REQUEST['stopwords'];
			$swarray = explode( "\n"  , $sw );
			$out = "";
			foreach($swarray as $v) {
				$v = trim($v);
				if(strlen($v)>0) {
					$out = $v."\n".$out;
				}
			}
			io_saveFile( $this->stopwords_fn(), $out);
			return $this->getLang('Admin_SavedFile');
		}
		return '';
	}
 
	function read_stopwords() {
 
		if (@ file_exists( $this->stopwords_fn() )) {
		    //$words = explode('\n', io_readfile( $this->stopwords_fn() ));
			$words = gzfile( $this->stopwords_fn() );
			sort($words, SORT_STRING);
			return implode("", array_values($words));
		} else {
			return "";
		}	
	}
 
	function html() {
		global $ID;
		global $_POST;
 
 
		ptln("<h1>" . $this->getLang('Admin_MenuText') . "</h1>");
		ptln('<div class="cloud" id="outer">');
		//ptln('<div class="cloud" id="cloud_message">Javascript is not enabled.</div>');
		ptln('<b>' . $this->save_stopwords() . '</b></br />');
 
?>
<script language="JavaScript" type="text/javascript" charset="utf-8">
<!--//--><![CDATA[//><!--
 
	//document.getElementById( 'cloud_message' ).innerHTML = 'Javascript is enabled';
 
	function append_word( Tag, word ) {
		words = document.getElementById( Tag );
		newline = "\n";
		if( (words.value.length < 1) || (words.value.substring(1,0) == newline) ){
			//alert('The word is being appended');
			words.value = words.value + word + newline;
		} else {
			//alert('The word is being appended(2)');
			words.value = words.value + newline + word + newline;
		}
	} /* append_word */
 
	function CloudWordClicked( Tag ) {
		//alert('You clicked on tag "' + Tag + '"');
	    elem = document.getElementById( Tag );
		if( elem ) {
			//alert('The word is "' + elem.innerHTML + '"');
			//alert('The class is "' + elem.className + '"');
			if(elem.className.substring(2, 0) == '_a') {
				alert('That word was selected before');
			} else {
				elem.className = elem.className + '_a';
				//if(elem.className.substring(2, 0) == '_a') {
				//	alert('Word Selected is "' + elem.innerHTML + '"');
				//}  else {
				//	alert('The class is now "' + elem.className + '"');
				//}
 
				append_word('stopwords', elem.innerHTML );
			}
		} else {
			alert('The element was not found.');
		}
 
	} /* CloudWordClicked */
//--><!]]>
</script>
<?PHP
		ptln('<div class="cloud" id="left">');
		ptln('<form id="stopwords_form" action="' . wl($ID, array('do'=>'Admin', 'page'=>'cloud')) . '" method="POST" enctype="application/x-www-form-urlencoded">');
		//ptln('<input type="hidden" id="do" value="admin"/>');
		//ptln('<input type="hidden" id="page" value="cloud"/>');
		ptln("<fieldset class='cloud'><legend>" . $this->getLang('Admin_StopwordLabel') . "</legend>");
		ptln("<textarea id='stopwords' name='stopwords' cols='40' rows='25'>" . $this->read_stopwords() . '</textarea>');
		ptln('<br /><input type="submit" value="' .  $this->getLang('Admin_Save') . '" class="button" />');
		ptln('</fieldset></form></div> <!-- name="left" -->');
 
        ptln('<div class="cloud" id="right">');
 
		if($words = plugin_load('syntax', 'cloud')) {
			$num = 200;
			ptln("<div id='tagcloud'><fieldset class='cloud'>");
			ptln(DOKU_TAB . "<legend id='tagcloud'>" . $this->getLang('Admin_TagCloudLabel') . "</legend>");
			if (!(plugin_isdisabled('tag') || (!$tag = plugin_load('helper', 'tag'))) ) {
		        $tag_cloud = $words->_getTagCloud($num, $min, $max, $tag);
  	        }
			$this->_WordCloudDisplay($tag_cloud, $min, $max );
			ptln("</fieldset></div> <!-- id='tagcloud' -->");
 
			ptln("<div id='wordcloud'><fieldset class='cloud'>");
			ptln(DOKU_TAB . "<legend id='wordcloud'>" . $this->getLang('Admin_WordCloudLabel') . "</legend>");
        	$word_cloud = $words->_getWordCloud($num, $min, $max);
			$this->_WordCloudDisplay($word_cloud, $min, $max );
			ptln("</fieldset></div> <!-- id='wordcloud' -->");
		} else {
			ptln("<b>" . $this->getLang('Admin_WordCloudError') . "</b>");
		}			
		ptln('</div> <!-- id="right" -->');
 
		ptln('</div> <!-- id="outer" -->');
 
		$this->phpinfo();
	} // html()
 
 	function _WordCloudDisplay( $cloud, $min, $max ) {
 
		static $cloud_count = 0; 
 
		if (!$cloud || (count($cloud) == 0)) {
			ptln($this->getLang('Admin_EmptyList'));
			return;
		}
 
		$cloud_count++;
		$tag_count = 1;
		$delta = ($max-$min)/16;
 
 
		foreach ($cloud as $word => $size){
			if ($size < $min+round($delta)) $class = 'cloud1';
			elseif ($size < $min+round(2*$delta)) $class = 'cloud2';
			elseif ($size < $min+round(4*$delta)) $class = 'cloud3';
			elseif ($size < $min+round(8*$delta)) $class = 'cloud4';
			else $class = 'cloud5';
 
			if($conf['userewrite'] == 2) {
				$link = wl($word, array('do'=>'search', 'id'=>$word));
				$title = $size;
			} else {
				$link = wl($word, 'do=search');
				$title = $size;
			}
			$tag_id = "cloud_$cloud_count" . "_$tag_count";
			ptln(DOKU_TAB . DOKU_TAB . '<a class="' . $class . '" id="' . $tag_id . '" name="' . $tag_id . '" href="javascript:void(0);" onclick="CloudWordClicked( \'' . $tag_id . '\' );">' . $word .'</a>');  // .DOKU_LF 
			//ptln(DOKU_TAB . DOKU_TAB . '<a class="' . $class . '" id="' . $tag_id . '" name="' . $tag_id . '" href="javascript:CloudWordClicked( \'' . $tag_id . '\' );">' . $word .'</a>');  // .DOKU_LF
			$tag_count++; 
		} 
	}
 
	function phpinfo() {
 
	}
} 
